/////////////////////////////////////////////////////////////////////////////////
//
// BkMessage.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMessage.cpp,v $
 * Revision 1.3  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.1  2000/07/05 23:50:32  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.2  2000/07/01 23:48:09  syou
 * - FindMIMEItemFirst()bugfix
 *
 * Revision 1.1  2000/06/29 15:53:11  syou
 * - class CBkMessageAclass CBkMailPartAclass CBkMail
 *   FindMIMEItemFirst()A FindMIMEItemNext()A ExploreItemTree()A
 *   IsMIMEItem()AȂǂȂǎBׂẮAPGPDecodevO
 *   邽߁BJavaCNnewIuWFNg߂悤
 *   ̂ŁAdeleteȂ΂ȂȂԂA
 *   Ȃ߃Ã΃ǃЃуŃʃł́Atemplate class count_ptr
 *   BA͏O̖{Ƃ肾̂Ȃ̂ŁAŐV
 *   ł͂ȂmȂBŔނWeby[WQƂKv邩
 *   ȁBDecoden̎͂ꂩȂ̂ŁA PGPsdk̃TvvO
 *   Ă (^^;  ܂܂ꂩ炾cc
 *
 *
 */

#include "BkMail.h"


/////////////////////////////////////////////////////////////////////////////////
//
CBkMessage::CBkMessage()
{
    m_pbka = CB2API::Instance();
    m_pItem = NULL;
}


CBkMessage::CBkMessage(const CBkMessage& bm)
{
    m_pbka = bm.m_pbka;
    m_pItem = bm.m_pItem;
    m_listItem = bm.m_listItem;
}


CBkMessage::~CBkMessage()
{
}


CBkMessage& CBkMessage::operator =(const CBkMessage& bm)
{
    if (this != &bm) {
        m_pbka = bm.m_pbka;
        m_pItem = bm.m_pItem;
        m_listItem = bm.m_listItem;
    }
    return *this;
}


void CBkMessage::ExploreItemTree(LPCTSTR lpszType, LPCTSTR lpszSubType, CMIMEItem* pItem, DWORD dwFlag)
{
    if (pItem == NULL) {
        return;
    }

    if ((!lpszType || (lpszType && stricmp(lpszType, pItem->m_szType) == 0)) &&
        (!lpszSubType || (lpszSubType && stricmp(lpszSubType, pItem->m_szSubType) == 0)) ) {
        m_listItem.push_back(pItem);
    }

    if (dwFlag & FINDMIMEITEM_FIRST_CHILD) {
        CMIMEItem* pMimeItem = pItem->GetChild();
        if (pMimeItem) {
            if (dwFlag & FINDMIMEITEM_FIRST_ONE) {
                dwFlag ^= FINDMIMEITEM_FIRST_CHILD;
            }
            ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
        }
        if (dwFlag & FINDMIMEITEM_NEXT) {
            pMimeItem = pItem->GetNext();
            if (pMimeItem) {
                if (dwFlag & FINDMIMEITEM_SECOND_ONE) {
                    dwFlag ^= FINDMIMEITEM_NEXT;
                }
                ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
            }
        }
    }
    else if (dwFlag & FINDMIMEITEM_FIRST_NEXT) {
        CMIMEItem* pMimeItem = pItem->GetNext();
        if (pMimeItem) {
            if (dwFlag & FINDMIMEITEM_FIRST_ONE) {
                dwFlag ^= FINDMIMEITEM_FIRST_NEXT;
            }
            ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
        }
        if (dwFlag & FINDMIMEITEM_CHILD) {
            pMimeItem = pItem->GetNext();
            if (pMimeItem) {
                if (dwFlag & FINDMIMEITEM_SECOND_ONE) {
                    dwFlag ^= FINDMIMEITEM_CHILD;
                }
                ExploreItemTree(lpszType, lpszSubType, pMimeItem, dwFlag);
            }
        }
    }
}

