/////////////////////////////////////////////////////////////////////////////////
//
// SignatureData.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: SignatureData.h,v $
 * Revision 1.1  2000/07/07 14:11:55  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.1  2000/07/05 23:50:34  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 */

#pragma once


#include <windows.h>
#include <pgpKeys.h>
#include <pgpEncode.h>

/////////////////////////////////////////////////////////////////////////////////
//
class CEventData
{
public:
    virtual ~CEventData() {}
    virtual void SetEventData(PGPEvent* event) = 0;
};


/////////////////////////////////////////////////////////////////////////////////
//
class CSignatureData : public CEventData
{
public:
    CSignatureData()
    {
        name = NULL;
    }
    virtual ~CSignatureData()
    {
        delete [] name;
        name = NULL;
    }

    void SetEventData(PGPEvent* event);
    const PGPEventSignatureData GetData() const
    {
        return sigData;
    }
    const char* GetName() const
    {
        return name;
    }

protected:
private:
	char* name;
    PGPEventSignatureData sigData;
};


/////////////////////////////////////////////////////////////////////////////////
//
void CSignatureData::SetEventData(PGPEvent* event)
{
    PGPEventSignatureData* data = reinterpret_cast<PGPEventSignatureData*>(&event->data.signatureData);
    sigData.signingKeyID = data->signingKeyID;
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = data->checked;
    sigData.verified = data->verified;
    sigData.keyRevoked = data->keyRevoked;
    sigData.keyDisabled = data->keyDisabled;
    sigData.keyExpired = data->keyExpired;
    sigData.keyMeetsValidityThreshold = data->keyMeetsValidityThreshold;
    sigData.keyValidity = data->keyValidity;
    sigData.creationTime = data->creationTime;

    delete [] name;
    name = NULL;
	PGPSize	namelen = 0;
	PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
    name = new char[namelen+1];
	PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
}
